#!/bin/sh
#Check.sh v1.14.3 by Roi Dayan

#Cronatb example line: (Will execute every 15 minutes)
#---------------
#*/15 * * * *	/usr/local/Internet/Check.sh >/dev/null 2>&1
#---------------

#This is what to run to activate the connection:
conn='/usr/local/Internet/Cables_Start.sh'

#Temp file to check if this script is running:
ttmp='/tmp/Check_Touch.tmp'

#This is to de-activate:
deconn='killall pppd pptp ; sleep 2 ; killall -9 pppd pptp'

#Interface to check:
myint='ppp0'

#When interface is up to try to ping remote ? (yes/no)
toping='yes'
#IP to ping to check if your internet is alive.
pingip='212.117.129.3' #I use my isp name server.
#The next line will take the remote ip of your external interface.
#(Works if you use ppp interface, no idea about eth or other)
#pingip=`netstat -nr | grep $myint | awk {'print $1'} | grep -v 0.0.0.0`


#

if [ -f $ttmp ]; then
 if $(kill -CHLD `cat $ttmp` >/dev/null 2>&1); then
  echo "This script is already running. (If not try to delete $ttmp)"
  exit 2
 else
  rm -f $ttmp
 fi
fi

echo $$ > $ttmp
echo -n "Checking $myint interface: "
chk1=`/sbin/ifconfig $myint 2>/dev/null`
if [ "$chk1" = "" ]; then
 chk1="no"
else
 chk1="yes"
fi

if [ "$chk1" = "no" ]; then
 echo "down, activating."
 eval $deconn
 sleep 2
 $conn
 r=$?
 rm -f $ttmp
 exit $r
else
 echo "up."
 if [ "$toping" = "yes" ]; then
#  getip=`echo \`netstat -nr | grep $myint | cut -d \  -f 1\` | cut -d \  -f 1`
  getip=$pingip
  echo -n "Trying to ping $getip: "
  if [ "$getip" = "" ]; then
   chk2="no"
  else
   chk2=`ping $getip -c 1 -i 40 2>/dev/null | grep loss | cut -d , -f 3 | cut -d \  -f 2`
   echo "$chk2 packet loss."
   if [ "$chk2" = "" ]; then
    chk2="no"
   else
    if [ "$chk2" = "100%" ]; then
     chk2="no"
    else
     chk2="yes"
    fi
   fi
  fi
  if [ "$chk2" = "no" ]; then
   echo -n "Can't ping, killing... "
   eval $deconn
   echo -n "Sleeping 6 seconds... "
   sleep 6
   echo "Activating."
   $conn
   r=$?
   rm -f $ttmp
   exit $r
  else
   echo "Connection is up."
   rm -f $ttmp
   exit 2
  fi
 fi
fi
echo "Check Me!"
exit 0
